//******************************************************************
// freezestatus.sp
// 12/4/2007 GenKernel
// freeze status for sourceforts 1.9.3 for sourcemod
// orignal idea taken from http://www.sourcefortsmod.com/boards/showthread.php?t=2795
//******************************************************************

#include <sourcemod>
#include <sdktools>
#include <entity>




//*******************************************
// Need to find out how to know MAX Entities
// or a better way to store the blockID info
//******************************************
#define Max_Entities 2085
new String:gBlockFrozenClientName[Max_Entities][64]
new String:gBlockFrozenClientID[Max_Entities][32]

new String:gBlockUnfrozenClientName[Max_Entities][64]
new String:gBlockUnfrozenClientID[Max_Entities][32]



public Plugin:myinfo =
{
	name = "Freeze Status",
	author = "GenKernel",
	description = "Shows who last changed the status of a block",
	version = "1.0.0.2",
	url = ""
}
 

public OnPluginStart()
{

	HookEvent("block_frozen", Event_Block_Frozen)
	HookEvent("block_unfrozen", Event_Block_Unfrozen)
	
	RegConsoleCmd("freezestatus", Freeze_Status)
}


public OnMapStart()
{
	for (new i = 0; i < Max_Entities; i++)
	{
		strcopy(gBlockFrozenClientName[i], 64, "")
		strcopy(gBlockFrozenClientID[i], 32, "")
		
		strcopy(gBlockUnfrozenClientName[i], 64, "")
		strcopy(gBlockUnfrozenClientID[i], 32, "")
	}
}


public Action:Freeze_Status(client, args)
{
	new blockid = GetClientAimTarget(client, false)
	
	new String:classname[64];
 	
	if (blockid > 0)
	{
		GetEntityNetClass(blockid, classname, 64);
	}
	
	if (StrEqual(classname, "CPhysicsPropBlock"))
	{
		
		if (!StrEqual(gBlockFrozenClientName[blockid], "", false))
		{
			PrintToChat(client, "Freeze Status -- Block %d last frozen by %s SteamID %s" , blockid, gBlockFrozenClientName[blockid], gBlockFrozenClientID[blockid])
			PrintToConsole(client, "Freeze Status -- Block %d last frozen by %s SteamID %s" , blockid, gBlockFrozenClientName[blockid], gBlockFrozenClientID[blockid])
		}
		else
		{
			PrintToChat(client, "Freeze Status -- Block %d last frozen by WORLD" , blockid)
			PrintToConsole(client, "Freeze Status -- Block %d last frozen by WORLD" , blockid)
		}
		
		if (!StrEqual(gBlockUnfrozenClientName[blockid], "", false))
		{
			PrintToChat(client, "Freeze Status -- Block %d last unfrozen by %s SteamID %s" , blockid, gBlockUnfrozenClientName[blockid], gBlockUnfrozenClientID[blockid])
			PrintToConsole(client, "Freeze Status -- Block %d last unfrozen by %s SteamID %s" , blockid, gBlockUnfrozenClientName[blockid], gBlockUnfrozenClientID[blockid])
		}
		else
		{
			PrintToChat(client, "Freeze Status -- Block %d last unfrozen by WORLD" , blockid)
			PrintToConsole(client, "Freeze Status -- Block %d last unfrozen by WORLD" , blockid)
		}
	}
	
	return Plugin_Handled;
}


public Action:Event_Block_Frozen(Handle:event, const String:name[], bool:dontBroadcast)
{

	new playerid = GetEventInt(event, "userid")
	new blockid = GetEventInt(event, "blockid")

	if (playerid > 0)
	{
		GetClientName(playerid, gBlockFrozenClientName[blockid], 64)
		GetClientAuthString(playerid, gBlockFrozenClientID[blockid], 32)
	}
	else 
	{
		strcopy(gBlockFrozenClientName[blockid], 64, "")
		strcopy(gBlockFrozenClientID[blockid], 32, "")
	}
}

public Action:Event_Block_Unfrozen(Handle:event, const String:name[], bool:dontBroadcast)
{
	new playerid = GetEventInt(event, "userid")
	new blockid = GetEventInt(event, "blockid")

	if (playerid > 0)
	{
		GetClientName(playerid, gBlockUnfrozenClientName[blockid], 64)
		GetClientAuthString(playerid, gBlockUnfrozenClientID[blockid], 32)
	}
	else
	{
		strcopy(gBlockUnfrozenClientName[blockid], 64, "")
		strcopy(gBlockUnfrozenClientID[blockid], 32, "")
	}
}
